//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "PhysikCombo_II.h"
#include "PhysikEingabe.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck wird benutzt, um sicherzustellen, da die erzeugten Komponenten keine
// rein virtuellen Funktionen haben.
//

static inline void ValidCtrCheck(KPhysikCombo_II *)
{
        new KPhysikCombo_II(NULL);
}
//---------------------------------------------------------------------------
__fastcall KPhysikCombo_II::KPhysikCombo_II(TComponent* Owner)
        : TComboBox(Owner)
{
        this->Parent=(TWinControl*)Owner;
        // Default-Werte setzen
        /* Drfen nicht mehr im Konstruktor stehen, da
          neue Kokmponente PhysikEingabe durch Aggregation
          entsteht => Problem Handle !!!!!!!!
        */
        //SetEinheiten(Masse_pro_Zeit);
        //AuswahlIndex=0;
        
}


//---------------------------------------------------------------------------
namespace PhysikCombo_II
{
        /*
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(KPhysikCombo_II)};
                 RegisterComponents("Beispiele", classes, 0);
        }
        */
}
//---------------------------------------------------------------------------

/* "umrechnen" rechnet uebergebenen Wert von eingestellter
 Einheit in KPhysikCombo_II-Komponente
 in SI-Einheit um */
void __fastcall KPhysikCombo_II::User_defined(AnsiString SI_Einheit)
{
  Items->Clear();
  Items->Add(SI_Einheit);  // SI-Wert
  FUmrechnungsMatrix[0]=1;     // hat Umrechnungsdfaktor 1
  FUmrechnungsFaktor=FUmrechnungsMatrix[0];
  AuswahlIndex=0;

}

//void __fastcall KPhysikCombo_II::Hide_Combo(bool t)
//     {
//      Visible=t;
//     }


void __fastcall KPhysikCombo_II::Add_User_defined(AnsiString Einheit, double Umrechnung)
{
  Items->Add(Einheit);
  FUmrechnungsMatrix[Items->Count-1]=Umrechnung; // Umrechnungsfaktor setzen
  FUmrechnungsFaktor=FUmrechnungsMatrix[0];
  AuswahlIndex=0;
}

double __fastcall KPhysikCombo_II::umrechnen(double val)
{
        if(Einheiten==Temperatur)
        {
          // Konstante fr Umrechnung F->K
          double konst=(double) 5/9;

          switch(AuswahlIndex)
          {
            case 0:
                return val;

            case 1:
                return val+UmrechnungsFaktor;

            case 2:
                val=konst*(val-32);
                return val+UmrechnungsFaktor;

            default:      // Fehlermeldung
                Application->MessageBox(
                "Es ist ein Fehler aufgetreten (kein Element ausgewaehlt)",
                "Fehlermeldung",MB_OKCANCEL);
                break;
           }
        }
        if(Einheiten==Eins_pro_Temperatur)
        {
          // Konstante fr Umrechnung F->K
          double konst=(double) 5/9;

          switch(AuswahlIndex)
          {
            case 0:
                return val;

            case 1:
                return 1./(1./val+UmrechnungsFaktor);

            case 2:
                val=konst*(1./val-32)+UmrechnungsFaktor;
                return 1./val;

            default:      // Fehlermeldung
                Application->MessageBox(
                "Es ist ein Fehler aufgetreten !! (kein Element ausgewaehlt)",
                "Fehlermeldung",MB_OKCANCEL);
                break;
           }
        }
        else // Einheiten!=Temperatur
        {
          if(AuswahlIndex!=-1)  // falls ein Item ausgewhlt
                return val*UmrechnungsFaktor;
          else    // Fehlermeldung
                Application->MessageBox(
                "Es ist ein Fehler aufgetreten (kein Element ausgewaehlt)",
                "Fehlermeldung",MB_OKCANCEL);
        }
        return 0; // wird zwar nie erreicht, aber Compiler
                  // spuckt sonst eine Fehlermeldung aus

}

//---------------------------------------------------------------------------

/* "umrechnenVonSI" rechnet Wert val von Si-Einheit nach
  in KPhysikCombo_II-Komponente eingestellter Einheit um
*/

double __fastcall KPhysikCombo_II::umrechnenVonSI(double val)
{
        if(Einheiten==Temperatur)
        {
           double konst=(double) 9/5;
           switch(AuswahlIndex)
           {
             case 0:
                return val;
             case 1:
                return val-UmrechnungsFaktor;
             case 2:

                return konst*(val-UmrechnungsFaktor)+32;
             default:
                Application->MessageBox(
                "Es ist ein Fehler aufgetreten (kein Element ausgewaehlt)",
                "Fehlermeldung",MB_OKCANCEL);

           }
        }

        if(Einheiten==Eins_pro_Temperatur)
          {
              double konst=(double) 9/5;
              switch(AuswahlIndex)
              {
              case 0:
                return val;
              case 1:
                return 1./(1./val-UmrechnungsFaktor);
              case 2:
                return 1./(konst*(1./val-UmrechnungsFaktor)+32);
              default:
                Application->MessageBox(
                "Es ist ein Fehler aufgetreten (kein Element ausgewaehlt)",
                "Fehlermeldung",MB_OKCANCEL);

              }
          }
        else
          {
              if(val!=0)
                 return val*val/umrechnen(val);
              else
                 return val;
          }
        return 0; //sonst CompilerWarnung
}

//---------------------------------------------------------------------------

void __fastcall KPhysikCombo_II::SetFaktor(void)
{
        Change();
}

//---------------------------------------------------------------------------

void __fastcall KPhysikCombo_II::SetAuswahlIndex(int ind)
{
        if(GetAuswahlIndex()!=ind)
          SendMessage(Handle, CB_SETCURSEL, ind,0);
        FUmrechnungsFaktor=FUmrechnungsMatrix[AuswahlIndex];
}

int __fastcall KPhysikCombo_II::GetAuswahlIndex(void)
{
        return SendMessage(Handle, CB_GETCURSEL, 0,0);
}


void __fastcall KPhysikCombo_II::SetEinheiten(Einheit aEinheiten)
{
        FEinheiten=aEinheiten;
}

