//---------------------------------------------------------------------------
#ifndef PhysikCombo_IIH
#define PhysikCombo_IIH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
enum Einheit{
        keine_Einheit,
        Eins_pro_Temperatur,
        Masse_pro_Zeit,
        Energie_pro_Masse_und_Temperatur,
        Energie_pro_Masse,
        Masse_pro_Volumen,
        Laenge_pro_Zeit,
        Laenge,Zeit,
        Masse,
        Volumen_pro_Zeit,
        Druck,
        Energie_pro_Stoffmenge,
        Leistung_pro_Masse_und_Temperatur,
        Leistung_pro_Laenge_und_Temperatur,
        Leistung_pro_Flaeche,
        Anteil_Prozent,
        Temperatur,
        User_defined,
        Kraft,
        Kraft_pro_Flaeche
        };

class PACKAGE KPhysikCombo_II : public TComboBox
{
private:
        int FAuswahlIndex;

protected:
       void __fastcall SetEinheiten(Einheit aEinheit);
        void __fastcall zeige(AnsiString var, float val);
        void __fastcall SetAuswahlIndex(int ind);
        int __fastcall GetAuswahlIndex(void);

public:
      DYNAMIC void __fastcall Change()           // nur voruebergehend public
        {
          //ShowMessage("Change");
          if(AuswahlIndex!=-1)
          {
            FUmrechnungsFaktor=FUmrechnungsMatrix[AuswahlIndex];
          }
          TComboBox::Change();
        }
        void __fastcall User_defined(AnsiString SI_Einheit);
        void __fastcall Add_User_defined(AnsiString Einheit, double Umrechnung);


   double FUmrechnungsFaktor;                 // NUR
   double FUmrechnungsMatrix[20];             // VORBERGEHEND
   /*
    Wert  Einheit[i] = Wert * FUmrechnungsMatrix[i] SI_Einheit
    Bsp:
     1 dm = 1 * 0.1 m    // Umrechnungsfaktor: 0.1
   */

   Einheit FEinheiten;                        // PUBLIC
        __fastcall KPhysikCombo_II(TComponent* Owner);
    virtual double __fastcall umrechnen(double val);
    virtual double __fastcall umrechnenVonSI(double val);
    virtual void __fastcall SetFaktor(void);
//    virtual void __fastcall Hide_Combo(bool t);    
    __property int ItemIndex={};
__published:
        __property double UmrechnungsFaktor={read=FUmrechnungsFaktor};
       /* Wert in SI = Wert in aktueller Einheit * UmrechnungsFaktor
          Ausnahme Temperatur: Verschiebung um 273,12 Grad */

        __property Einheit Einheiten={read=FEinheiten,write=SetEinheiten};
        __property int AuswahlIndex=
                {read=GetAuswahlIndex,write=SetAuswahlIndex};
};
//---------------------------------------------------------------------------
#endif



