//---------------------------------------------------------------------------
// Borland C++Builder
// Copyright (c) 1987, 1998 Borland International Inc.  All Rights Reserved.
//---------------------------------------------------------------------------
#include "cdblspin.h"
#include "samp.h"
#include <dialogs.hpp> // zum debuggen
#pragma resource "*.res"  
#pragma resource "updown.res"
#pragma package(smart_init)

//---------------------------------------------------------------------------
namespace Cdblspin {
/*
void __fastcall PACKAGE Register()
{
  TComponentClass classes[1] = {__classid(TCDoubleSpinEdit)};
  RegisterComponents(LoadStr(Tab_101),
                     classes,
                     (sizeof(classes)/sizeof(classes[0])) - 1);
} */
} //end namespace

//---------------------------------------------------------------------------
// TCSpinButton

__fastcall TCSpinButton::TCSpinButton(TComponent *AOwner)
                      : TWinControl(AOwner)
{
  (((ControlStyle >> csAcceptsControls)
                  >> csSetCaption)
                  << csFramed)
                  << csOpaque;

  FUpButton = CreateButton();
  FDownButton = CreateButton();
  UpGlyph = NULL;
  DownGlyph = NULL;

  Width = 20;
  Height = 25;
  FFocusedButton = FUpButton;
}

TTimerSpeedButton *__fastcall TCSpinButton::CreateButton(void)
{
  TTimerSpeedButton * Result;

  Result = new TTimerSpeedButton((TComponent *) this);
  Result->OnClick = BtnClick;
  Result->OnMouseDown = BtnMouseDown;
  Result->Visible = True;
  Result->Enabled = True;
  Result->TimeBtnState << tbAllowTimer;
  Result->NumGlyphs = 1;
  Result->Parent = this;

  return Result;
}

void __fastcall TCSpinButton::AdjustSize(int &W, int &H)
{
  if ((FUpButton == NULL))//||(ComponentState.Contains(csLoading)))
     return;

  if (W < 15)
      W = 15;

  FUpButton->SetBounds (0, 0, W, H / 2);
  FDownButton->SetBounds (0, FUpButton->Height - 1, W, H - FUpButton->Height + 1);
}

void __fastcall TCSpinButton::SetBounds(int ALeft, int ATop, int AWidth, int AHeight)
{
  int W, H;

  W = AWidth;
  H = AHeight;
  AdjustSize (W, H);
  TWinControl::SetBounds (ALeft, ATop, W, H);
}

void __fastcall TCSpinButton::WMSize(TWMSize &Message)
{
  int W, H;
  TWinControl::Dispatch(&Message);
  // check for minimum size
  W = Width;
  H = Height;
  AdjustSize (W, H);

  if ((W != Width) || (H != Height))
      TWinControl::SetBounds(Left, Top, W, H);

  Message.Result = 0;
}

void __fastcall TCSpinButton::WMSetFocus(TWMSetFocus &Message)
{
  FFocusedButton->TimeBtnState << tbFocusRect;
  FFocusedButton->Invalidate();
}

void __fastcall TCSpinButton::WMKillFocus(TWMKillFocus &Message)
{
  FFocusedButton->TimeBtnState >> tbFocusRect;
  FFocusedButton->Invalidate();
}

void __fastcall TCSpinButton::KeyDown(Word &Key,  TShiftState Shift)
{
  switch (Key) {
    case VK_UP:
          SetFocusBtn (FUpButton);
          FUpButton->Click();
          break;
    case VK_DOWN:
          SetFocusBtn (FDownButton);
          FDownButton->Click();
          break;
    case VK_SPACE:
        FFocusedButton->Click();
  }
}

void __fastcall TCSpinButton::BtnMouseDown(TObject *Sender, TMouseButton Button,
                                       TShiftState Shift, int X, int Y)
{
  if (Button == mbLeft) {
    SetFocusBtn ((TTimerSpeedButton*) Sender);
    if((FFocusControl != NULL) && ( FFocusControl->TabStop ) &&
      (FFocusControl->CanFocus()) && (GetFocus() != FFocusControl->Handle))
            FFocusControl->SetFocus();
    else if (TabStop && (GetFocus() != Handle) && CanFocus() )
      SetFocus();
  }
}

void __fastcall TCSpinButton::BtnClick(TObject *Sender)
{
  if (Sender == FUpButton) {
    if (FOnUpClick != NULL)
        FOnUpClick(this);
  }
  else
    if (FOnDownClick != NULL)
       FOnDownClick(this);
}

void __fastcall TCSpinButton::SetFocusBtn(TTimerSpeedButton *Btn)
{
  if (TabStop && CanFocus() &&  (Btn != FFocusedButton)) {
    FFocusedButton->TimeBtnState >> tbFocusRect;
    FFocusedButton = Btn;
    if (GetFocus() == Handle) {
       FFocusedButton->TimeBtnState << tbFocusRect;
       Invalidate();
    }
  }
}

void __fastcall TCSpinButton::WMGetDlgCode(TWMNoParams &Message)
{
  Message.Result = DLGC_WANTARROWS;
}

void __fastcall TCSpinButton::Loaded(void)
{

  int W, H;

  W = Width;
  H = Height;
  AdjustSize (W, H);

  if ((W != Width) || (H != Height))
    TWinControl::SetBounds(Left, Top, W, H);
}

Graphics::TBitmap *__fastcall TCSpinButton::GetUpGlyph(void)
{
  Graphics::TBitmap * Result;

  Result = FUpButton->Glyph;
  return Result;
}

void __fastcall TCSpinButton::SetUpGlyph(Graphics::TBitmap *Value)
{
  if (Value != NULL)
    FUpButton->Glyph = Value;
  else {
    FUpButton->Glyph->Handle = LoadBitmap((void*) HInstance, "SpinUp");
    FUpButton->NumGlyphs = 1;
    FUpButton->Invalidate();
  }
}

Graphics::TBitmap *__fastcall TCSpinButton::GetDownGlyph(void)
{
  Graphics::TBitmap * Result;

  Result = FDownButton->Glyph;
  return Result;
}

void __fastcall TCSpinButton::SetDownGlyph(Graphics::TBitmap *Value)
{
  if (Value != NULL)
    FDownButton->Glyph = Value;
  else {
    FDownButton->Glyph->Handle = LoadBitmap((void*)HInstance, "SpinDown");
    FDownButton->NumGlyphs = 1;
    FDownButton->Invalidate();
  }
}

// TCSpinEdit

__fastcall TCDoubleSpinEdit::TCDoubleSpinEdit(TComponent *AOwner) : TCustomEdit(AOwner)
{
  FButton = new TCSpinButton(this);

  FButton->Width = 15;
  FButton->Height = 17;
  FButton->Visible = True;
  FButton->Parent = this;
  FButton->FocusControl = this;
  FButton->OnUpClick = UpClick;
  FButton->OnDownClick = DownClick;
  Text = "0";
  ControlStyle >> csSetCaption;
  FIncrement = 1;
  FEditorEnabled = True;
  FSpinCombo=NULL;
}

__fastcall TCDoubleSpinEdit::~TCDoubleSpinEdit(void)
{
  FButton = NULL;
}

void __fastcall TCDoubleSpinEdit::GetChildren(TGetChildProc Proc, TComponent * Root)
{
}

void __fastcall TCDoubleSpinEdit::KeyDown(Word &Key,  TShiftState Shift)
{
/*
  if ((Key >= '0') && (Key <= '9') && SelText!="")
  { // falls Text markiert wurde und danch eine Taste gedrckt wird
    // soll die berflssige Null unterdrckt werden
   //ShowMessage("markierter Text");
   ShowMessage(Text);

   } */

  if (Key == VK_UP)
    UpClick (this);
  else if (Key == VK_DOWN)
         DownClick (this);
  if (Key == VK_ESCAPE)
  {
    DoEscapePressed();

    // alten Wert wiederherstellen
    //Text=FFocusText;
    //FSpinCombo->AuswahlIndex=FFocusItem; //Fehler
    // da evtl noch umgerechnet wird, =>Problem:
    // Abspeichern des internen Wertes
  }
  if (Key == VK_PRIOR)
    Text = AnsiString(FSpinCombo->umrechnenVonSI(FMaxValue));
  if (Key == VK_NEXT)
    Text = AnsiString(FSpinCombo->umrechnenVonSI(FMinValue));
  TCustomEdit::KeyDown(Key, Shift);
}

void __fastcall TCDoubleSpinEdit::DoTastenDruck(void)
{
 if(FOnTastenDruck)
  FOnTastenDruck(this);
}

void __fastcall TCDoubleSpinEdit::DoKeyDruck(Char& Key)
{
 if(FOnKeyDruck)
  FOnKeyDruck(this,Key);
}


void __fastcall TCDoubleSpinEdit::KeyPress(Char& Key)
{
  if (!IsValidChar(Key)) {
    Key = 0;
    MessageBeep(0);
  }
  if (Key != 0)
    TCustomEdit::KeyPress(Key);
  DoTastenDruck();
  DoKeyDruck(Key);
}

bool __fastcall TCDoubleSpinEdit::IsValidChar(Char Key)
{
  bool Result;
  if(((Key == DecimalSeparator)       ||
      (Key == '+')                    ||
      (Key == '-')                    ||
     ((Key >= '0') && (Key <= '9')))  ||
     ((Key < 0x32) && (Key != Char(VK_RETURN))))
   Result = True;

  if (!(FEditorEnabled) &&
      Result &&
      ((Key >= 0x32) ||
       (Key == Char(VK_BACK)) ||
       (Key == Char(VK_DELETE))))
    Result = False;
  return Result;
}

void __fastcall TCDoubleSpinEdit::CreateParams(TCreateParams &Params)
{
  TCustomEdit::CreateParams(Params);
  //Params->Style &= ~WS_BORDER;
  Params.Style |=  ES_MULTILINE | WS_CLIPCHILDREN;
}

void __fastcall TCDoubleSpinEdit::CreateWnd()
{
  TCustomEdit::CreateWnd();
  SetEditRect();
}

void __fastcall TCDoubleSpinEdit::SetEditRect(void)
{
  TRect Loc;

  SendMessage(Handle, EM_GETRECT, 0, long(&Loc));
  Loc.Bottom = ClientHeight + 1;  // +1 is workaround for windows paint bug
  Loc.Right = ClientWidth - FButton->Width - 2;
  Loc.Top = 0;
  Loc.Left = 0;
  SendMessage(Handle, EM_SETRECTNP, 0, long(&Loc));
  SendMessage(Handle, EM_GETRECT, 0, long(&Loc));  // debug
}

void __fastcall TCDoubleSpinEdit::WMSize(TWMSize &Message)
{
  int MinHeight;

  MinHeight = GetMinHeight();
    // text edit bug: if size to less than minheight, then edit ctrl does
    //  not display the text
  if (Height < MinHeight)
    Height = MinHeight;
  else if (FButton != NULL) {
    if (NewStyleControls)
      FButton->SetBounds(Width - FButton->Width - 5, 0, FButton->Width, Height - 5);
    else FButton->SetBounds (Width - FButton->Width, 0, FButton->Width, Height);
    SetEditRect();
  };
}

int __fastcall TCDoubleSpinEdit::GetMinHeight(void)
{
  HDC DC;
  HFONT SaveFont;
  int I, Result;
  TTextMetric SysMetrics, Metrics;

  DC = GetDC(NULL);
  GetTextMetrics(DC, &SysMetrics);
  SaveFont = SelectObject(DC, Font->Handle);
  GetTextMetrics(DC, &Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  I = SysMetrics.tmHeight;
  if (I > Metrics.tmHeight)
    I = Metrics.tmHeight;

  Result = Metrics.tmHeight + I / 4 + GetSystemMetrics(SM_CYBORDER) * 4 + 2;
  return Result;
}

void __fastcall TCDoubleSpinEdit::UpClick(TObject *Sender)
{
  if (ReadOnly)
    MessageBeep(0);
  else Value += FIncrement;
}

void __fastcall TCDoubleSpinEdit::DownClick(TObject *Sender)
{
  if (ReadOnly)
    MessageBeep(0);
  else
    Value -= FIncrement;
}

void __fastcall TCDoubleSpinEdit::WMClear(TWMNoParams &Message)
{
 //ShowMessage("Clear");
}


void __fastcall TCDoubleSpinEdit::WMPaste(TWMNoParams &Message)
{
 // ShowMessage("Paste");
  if (!FEditorEnabled || ReadOnly)
    return;
}

void __fastcall TCDoubleSpinEdit::WMCut(TWMNoParams &Message)
{
 // ShowMessage("clear");
  if (!FEditorEnabled || ReadOnly)
    return;
}

/*
void __fastcall TCDoubleSpinEdit::CMExit(TWMNoParams &Message)
{
  //Application->MessageBox("Exit","Exit",MB_OK);
  if (CheckValue (Value) != Value)
    //SetValue (Value);
   {
     AnsiString Ansage="Der Wert liegt nicht im Intervall von\n";
     Ansage+=AnsiString(FMinValue)+" "+FSpinCombo->Items->Strings[0];
     Ansage+=" bis " + AnsiString(FMaxValue)+" "+FSpinCombo->Items->Strings[0];
     Application->MessageBox(Ansage.c_str(),"Meldung",MB_OK);
     SetFocus();
   }

}

*/
/*
Die Botschaft CM_Exit wird in KPhysikeingabe behandelt!!!!!
*/

double __fastcall TCDoubleSpinEdit::GetValue(void)
{
  double Result;
  try {
    if(Text=="" ||Text=="-")
     {
    // ShowMessage("Text=nichts");
     return 0;
     }
    Result = Text.ToDouble();
    }
  catch(...) {                          // Bsp. Text="12f"  Problem "1f2"
        Text=Text.Delete(Text.Length(),1);  // letzten Buchstaben lschen
        try{                           // Test="12"
         Result = Text.ToDouble();
         }
        catch(...){         // Fehler, falls Text=""
          Text=AnsiString((double)FMinValue);
         return FMinValue;
        }
  }
  return Result;
}

void __fastcall TCDoubleSpinEdit::SetValue(double NewValue)
{
  Text = AnsiString((double)CheckValue(NewValue));
  //Text=AnsiString(NewValue); //CheckValue wird in KPhysikEingabe ausgefhrt
}



double __fastcall TCDoubleSpinEdit::CheckValue(double NewValue)
{

  double Result;
  NewValue = FSpinCombo->umrechnen(NewValue); // in SI-Wert umrechnen
  Result=NewValue;
  if (FMaxValue != FMinValue) {
    if (NewValue < FMinValue)
      Result = FMinValue;
    else if (NewValue > FMaxValue)
      Result = FMaxValue;
  }

  return FSpinCombo->umrechnenVonSI(Result); // zurckrechnen

}

void __fastcall TCDoubleSpinEdit::CMEnter(TWMNoParams &Message)
{
  if (AutoSelect && !(ControlState.Contains(csLButtonDown)))
    SelectAll();
}

void __fastcall TCDoubleSpinEdit::DoEscapePressed(void)
{
  if(FOnEscapePressed)
   FOnEscapePressed(this);
}

// TTimerSpeedButton

 __fastcall TTimerSpeedButton::TTimerSpeedButton(TComponent *AOwner) :
                               TSpeedButton(AOwner) { }

__fastcall TTimerSpeedButton::~TTimerSpeedButton()
{
  if (FRepeatTimer != NULL)
    delete FRepeatTimer;
}

void __fastcall TTimerSpeedButton::MouseDown(TMouseButton Button,  TShiftState Shift,
                          int X, int Y)
{
  TSpeedButton::MouseDown (Button, Shift, X, Y);

  if (FTimeBtnState.Contains(tbAllowTimer))
  {
    if (FRepeatTimer == NULL)
      FRepeatTimer = new TTimer(this);

    FRepeatTimer->OnTimer = TimerExpired;
    FRepeatTimer->Interval = InitRepeatPause;
    FRepeatTimer->Enabled  = True;
  };
}

void __fastcall TTimerSpeedButton::MouseUp(TMouseButton Button,  TShiftState Shift,
                                    int X, int Y)
{
  TSpeedButton::MouseUp (Button, Shift, X, Y);
  if (FRepeatTimer != NULL)
    FRepeatTimer->Enabled  = false;
}

void __fastcall TTimerSpeedButton::TimerExpired(TObject *Sender)
{
  FRepeatTimer->Interval = RepeatPause;
  if ((FState == bsDown) && MouseCapture) {
    try {
      Click();
    }
    catch(...) {
      FRepeatTimer->Enabled = false;
      throw;
    }
  }
}

void __fastcall TTimerSpeedButton::Paint(void)
{
  TRect R;

  TSpeedButton::Paint();
  if (FTimeBtnState.Contains(tbFocusRect)) {
    R.Left = 0;
    R.Top = 0;
    R.Right = Width;
    R.Bottom = Height;
    InflateRect(&R, -3, -3);
    if (FState == bsDown)
      OffsetRect(&R, 1, 1);
    DrawFocusRect(Canvas->Handle, &R);
  }
}

